import commonjs from '@rollup/plugin-commonjs';
import { nodeResolve } from '@rollup/plugin-node-resolve';
import versionInjector from 'rollup-plugin-version-injector';

export default {
  input: 'index.js',
  output: {
      file : 'i.js'
    , format: 'cjs'
  },
  // external: ['chessinstances'],
  // globals: { chessinstances : chessinstances},
  // external : [ 'chessinstances.js' ],
  // exclude : [ 'chessinstances.js' ],
  plugins: [commonjs({
    dynamicRequireTargets: [
      // include using a glob pattern (either a string or an array of strings)
      '**/cu*.js'
    ]
    // , 
    // exclude : [ 'chessinstances.js' ]
  }), nodeResolve(), versionInjector()]
};

// Dr Kamat
// Rahul Roji
// 06259